
;-----------------------------------------------------------------------------------------

_initialise	clrf	STATUS
	clrf	PCLATH	; set PCLATH to page 0
	clrf	PORTB

	bank1
	movlw	b'01110000'	; set OSCCON for internal RC oscillator
	movwf	OSCCON		; running at 8Mhz
	
	movlw	b'00000110'	; enable weak pull up on PORTB
	movwf	OPTION_REG	; set Prescaler for TMR0
			; If IntRC is set for 4Mhz, set prescale to 1:64
			; If IntRC is set for 8Mhz, set prescaler to 1:128

	clrf	ANSEL	; Set I/O ports for digital mode

	movlw	b'11011111'
	movwf	TRISB

	movlw	b'01100000'
	movwf	TRISA


			; If IntRC is set for 8Mhz, bit rate will be 38.4Kbs
	movlw	.12	; Set BRG for 19.2Kbs
	movwf	SPBRG
	movlw	b'00100100'
	movwf	TXSTA


	bank0

	movlw	b'10010000'
	movwf	RCSTA

	clrf	PORTA
	clrf	state

	clrf	INTCON
	bsf	INTCON, INTE


	bsf	INTCON, GIE	; enable Global interrupt


;---------------------------------------------------------------------------

;
; core code loop
;



_waitHere	btfsc	flags, irrxRdy
	call	_sendIRbinary
	goto	_waitHere


