;
; IR Receiver 
; Development code version 4
; Start Date: 02-03-2008
;
;
; Connections:
; IR Receiver TTL output to RB0  (use TSOP1738 / TSOP4838 or similar)
; Monitor LED to RA1
; Decoded serial out on RB5/TX  (8N1 @ 38.4Kbs) 
;
;
	#include "p16f88.inc"
	
;Program Configuration Register 1
		__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_ON & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _INTRC_IO

;Program Configuration Register 2
		__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF

;###########################################################################



;###########################################################################

          errorlevel -302     ; suppress banksel warning messages
          errorlevel -311     ; suppress HIGH operator warning messages

	cblock 0x20
	state
	bitCount
	irrxReg1
	irrxReg2
	irrxReg3
	bitCountBuf
	irrxBuf1
	irrxBuf2
	irrxBuf3
	binary
	asciiLo
	asciiHi
	a2byte
	returnStatus
	tempShift
	counter
	tempvar
	
	cmd12
	dev12
	ext20

	endc

	cblock 0x70
	Wisr
	Sisr
	flags

	endc

#define   bank0     bcf       STATUS,RP0          ; Sel Bank 0
#define   bank1     bsf       STATUS,RP0          ; Sel Bank 1



; flag bits
irrxRdy	equ 0

	org 0x000
	nop
	nop
	goto	_initialise
	
	org 0x004


	#include ir-interrupt4.inc
	#include ir-init4.inc
	#include ir-sio4.inc
	#include asciihex.inc



_error	movlw	'E'
	call	_serialTX
	movlw	.10
	call	_serialTX
	movlw	.13
	call	_serialTX
_halt	goto	_halt


	end
