
; Code here converts received IR bit stream into ASCII data and transmits via async serial I/O
; Coded for testing not optimisted.


_serialTX	btfss	PIR1, TXIF
	goto	$-1	; wait for TX buffer to empty
	movwf	TXREG
	return
	


_sendIR	movfw	irrxReg3
	call	_h2a
	movfw	asciiHi
	call	_serialTX
	movfw	asciiLo
	call	_serialTX

	movfw	irrxReg2
	call	_h2a
	movfw	asciiHi
	call	_serialTX
	movfw	asciiLo
	call	_serialTX
	movfw	irrxReg1
	call	_h2a
	movfw	asciiHi
	call	_serialTX
	movfw	asciiLo
	call	_serialTX

	movlw	.10
	call	_serialTX
	movlw	.13
	call	_serialTX
	bcf	flags,0	; reset ir data valid flag
	return

	; http://www.sbprojects.com/knowledge/ir/sirc.htm
	; http://www.hifi-remote.com/sony/

_sendIRbinary	movfw	bitCountBuf
	addlw	-.20
	bz	_fixup20
	addlw	.5
	bz	_fixup15
	addlw	.3
	bz	_fixup12


	; Can never get here because the IR receive code will error if bit length not valid
	; however, this code is left in for testing
_sendRaw	movfw	irrxBuf3
	call	_byteSend
	movfw	irrxBuf2
	call	_byteSend
	movfw	irrxBuf1
	call	_byteSend
	
	

_sendBitCount	movfw	bitCountBuf
_sendASCII	call	_h2a
	movfw	asciiHi
	call	_serialTX
	movfw	asciiLo
	call	_serialTX
	

	movlw	.10
	call	_serialTX
	movlw	.13
	call	_serialTX
	bcf	flags,0
	return


_byteSend	movwf	tempShift
	movlw	.8
	movwf 	counter
	movlw	0x18	; ASCII 0 = 0x30, shift right = 0x18
	movwf	tempvar

_binShift	rlf	tempShift,F	; shift left, 
	rlf	tempvar,W	; after shift W = 0x30 or 0x31 depending on carry
	call	_serialTX
	decfsz	counter,F
	goto	_binShift
	movlw	.32	; ASCII space
	call	_serialTX
	return
	

_fixup12	clrf	dev12
	clrf	cmd12
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F

	rrf	irrxBuf1,F
	rlf	cmd12,F
	rrf	irrxBuf1,F
	rlf	cmd12,F
	rrf	irrxBuf1,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F

	movlw	'c'
	call	_serialTX
	movfw	cmd12
	call	_byteSend
	movlw	'd'
	call	_serialTX
	movfw	dev12
	call	_byteSend
	movlw	0x12

	goto	_sendASCII


_fixup15	clrf	dev12
	clrf	cmd12
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F
	rrf	irrxBuf1,F
	rlf	dev12,F


	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F

	movlw	'c'
	call	_serialTX
	movfw	cmd12
	call	_byteSend
	movlw	'd'
	call	_serialTX
	movfw	dev12
	call	_byteSend
	movlw	0x15

	goto	_sendASCII



_fixup20	clrf	dev12
	clrf	cmd12
	clrf	ext20
	rrf	irrxBuf2,F
	rlf	dev12,F
	rrf	irrxBuf2,F
	rlf	dev12,F
	rrf	irrxBuf2,F
	rlf	dev12,F
	rrf	irrxBuf2,F
	rlf	dev12,F
	rrf	irrxBuf2,F
	rlf	dev12,F

	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf2,F
	rlf	cmd12,F
	rrf	irrxBuf3,F
	rlf	cmd12,F
	rrf	irrxBuf3,F
	rlf	cmd12,F
	rrf	irrxBuf3,F
	rlf	cmd12,F
	rrf	irrxBuf3,F
	rlf	cmd12,F
	
	rrf	irrxBuf1,F
	rlf	ext20,F
	rrf	irrxBuf1,F
	rlf	ext20,F
	rrf	irrxBuf1,F
	rlf	ext20,F
	rrf	irrxBuf1,F
	rlf	ext20,F
	rrf	irrxBuf1,F
	rlf	ext20,F
	rrf	irrxBuf1,F
	rlf	ext20,F
	rrf	irrxBuf1,F
	rlf	ext20,F
	rrf	irrxBuf1,F
	rlf	ext20,F

	movlw	'c'
	call	_serialTX
	movfw	cmd12
	call	_byteSend
	movlw	'd'
	call	_serialTX
	movfw	dev12
	call	_byteSend
	
	movlw	'x'
	call	_serialTX
	movfw	ext20
	call	_byteSend
	movlw	0x20

	goto	_sendASCII